org.appng.api.support

## Class ApplicationRequest

- java.lang.Object
- - org.appng.api.support.ApplicationRequest

- All Implemented Interfaces:
    Request, RequestSupport, ValidationProvider, RequestContainer, org.springframework.core.convert.ConversionService

      public class ApplicationRequest
      extends Object
      implements Request

  Default `Request` implementation, mostly delegating method-calls to one of the internal objects.
  Author:
    Matthias Müller

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `ApplicationRequest.ApplicationPath` Helper class used to simplify include conditions for actions and datasources on a page. Registered as variable `PATH`, so conditions can look like

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `I18N_VAR`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ApplicationRequest()`
    `ApplicationRequest(Request request, PermissionProcessor permissionProcessor, RequestSupport requestSupport)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addErrorMessage(FieldProcessor fp, MessageParam localizable)` Adds an error to the `FieldProcessor` using `FieldProcessor.addErrorMessage(String)`.
    `void` | `addErrorMessage(FieldProcessor fp, MessageParam localizable, String fieldBinding)` Adds an error to a `FieldDef` using `FieldProcessor.addErrorMessage(org.appng.xml.platform.FieldDef, String)`.
    `void` | `addParameter(String key, String value)`
    `void` | `addParameters(Map<String,String> singleParameters)`
    `void` | `addParameters(String name, List<String> values)`
    `void` | `addValidationMetaData(MetaData metaData, ClassLoader classLoader, Class<?>... groups)` Based on the JSR-303 annotations of the `MetaData`'s bindclass, this method adds the `Validation` to the `FieldDef`initions.
    `ApplicationRequest.ApplicationPath` | `applicationPath()` Creates a new `ApplicationRequest.ApplicationPath` to be used to evaluate include-conditions on a page.
    `boolean` | `canConvert(Class<?> sourceType, Class<?> targetType)`
    `boolean` | `canConvert(org.springframework.core.convert.TypeDescriptor sourceType, org.springframework.core.convert.TypeDescriptor targetType)`
    `<T> T` | `convert(Object source, Class<T> targetType)`
    `Object` | `convert(Object source, org.springframework.core.convert.TypeDescriptor sourceType, org.springframework.core.convert.TypeDescriptor targetType)`
    `void` | `fillBindObject(Object instance, FieldProcessor fp, RequestContainer container, ClassLoader classLoader)` Fills the given `bindobject` with the (converted) values provided by a `RequestContainer`.
    `List<String>` | `getAcceptedTypes(String uploadName)`
    `ApplicationConfigProvider` | `getApplicationConfig()`
    `Object` | `getBindObject(FieldProcessor fp, RequestContainer container, ClassLoader classLoader)` Creates, fills and returns a new bindobject.
    `String` | `getEncoding()`
    `Environment` | `getEnvironment()` Returns the `Environment` for this `Request`.
    `ExpressionEvaluator` | `getExpressionEvaluator()` Returns the `ExpressionEvaluator` for this `Request`.
    `FieldConverter` | `getFieldConverter()` Returns a `FieldConverter`
    `Map<String,List<FormUpload>>` | `getFormUploads()` Returns all `FormUpload`s for the request as immutable map.
    `List<FormUpload>` | `getFormUploads(String name)` Returns an immutable `List` of all `FormUpload`s for the parameter with the given name.
    `String` | `getHost()` Returns the host name for this request
    `javax.servlet.http.HttpServletRequest` | `getHttpServletRequest()`
    `LabelSupport` | `getLabelSupport()`
    `Locale` | `getLocale()` Returns the `Locale` for this `Request`.
    `String` | `getMessage(String key, Object... args)` Retrieves a message from the underlying `MessageSource`, using the `Locale` provided by `Environment.getLocale()`.
    `org.springframework.context.MessageSource` | `getMessageSource()` Returns the currently used `MessageSource`
    `String` | `getParameter(String name)` Returns the value for the parameter with the given name. Note that for a multi-valued parameter, any of the submitted values is returned.
    `List<String>` | `getParameterList(String name)` Returns a `List` containing all the values for the parameter with the given name.
    `Set<String>` | `getParameterNames()` Returns an immutable `Set` containing the names of all request parameters.
    `Map<String,String>` | `getParameters()` Returns an immutable `Map` containing the name of each request-parameter as a key and a single parameter value as the map's value. Note that for multi-valued parameters, the returned map contains any of the submitted values.
    `Map<String,List<String>>` | `getParametersList()` Returns an immutable `Map` containing the name of each request-parameter as a key and the list of submitted values as value.
    `ParameterSupport` | `getParameterSupportDollar()` Returns the `ParameterSupport` for this `Request`.
    `PermissionProcessor` | `getPermissionProcessor()` Returns the `PermissionProcessor` for this `Request`.
    `String` | `getRedirectTarget()`
    `RequestSupport` | `getRequestSupport()`
    `Subject` | `getSubject()` Returns the `Subject` for this `Request`.
    `List<String>` | `getUrlParameters()` Returns a list of URL-Parameters for a JSP-page, which are those path-elements appearing after the name of the JSP-page itself.
    `ValidationProvider` | `getValidationProvider()`
    `Request` | `getWrappedRequest()`
    `void` | `handleException(FieldProcessor fp, Exception e)` Handles an `Exception`.
    `boolean` | `hasParameter(String name)` Checks whether a parameter with the given name exists.
    `org.springframework.http.HttpHeaders` | `headers()` Returns the `HttpHeaders` for the underlying `HttpServletRequest`.
    `boolean` | `isGet()` Checks whether this `Request` originates of a HTTP GET-request.
    `boolean` | `isMultiPart()`
    `boolean` | `isPost()` Checks whether this `Request` originates of a HTTP POST-request.
    `boolean` | `isRedirect()` Checks whether a redirect-target has been set for this `Request`.
    `boolean` | `isValid()`
    `void` | `setAcceptedTypes(String uploadName, String... types)`
    `void` | `setApplicationConfig(ApplicationConfigProvider applicationConfigProvider)`
    `void` | `setEncoding(String encoding)`
    `void` | `setLabel(Label label)`
    `void` | `setLabels(Config config)`
    `void` | `setLabels(Config config, ParameterSupport fieldParameters)`
    `void` | `setLabels(Labels labels)`
    `void` | `setLabelSupport(LabelSupport labelSupport)`
    `void` | `setMaxSize(long maxSize)`
    `void` | `setMaxSize(long maxSize, boolean strict)`
    `void` | `setPermissionProcessor(PermissionProcessor permissionProcessor)`
    `<T> void` | `setPropertyValue(T source, T target, String property)` Copies the property from `source` to `target`.
    `<T> void` | `setPropertyValues(T source, T target, MetaData metaData)` Copies the fields defined by the given `MetaData` from `source` to `target`.
    `void` | `setRedirectTarget(String redirectTarget)`
    `void` | `setRequestSupport(RequestSupport requestSupport)`
    `void` | `setTempDir(File tempDir)`
    `void` | `setUrlParameters(List<String> urlParameters)`
    `void` | `setValidationProvider(ValidationProvider validationProvider)`
    `void` | `setWrappedRequest(Request wrappedRequest)`
    `void` | `validateBean(Object bean, FieldProcessor fp, Class<?>... groups)` Validates the given bean by adding error-messages to the `FieldDef` initions, using `FieldProcessor.addErrorMessage(FieldDef, String)`.
    `void` | `validateBean(Object bean, FieldProcessor fp, String[] excludeBindings, Class<?>... groups)` Validates the given bean by adding error-messages to the `FieldDef` initions, using `FieldProcessor.addErrorMessage(FieldDef, String)`.
    `void` | `validateField(Object bean, FieldProcessor fp, String fieldBinding, Class<?>... groups)` Validates a single `FieldDef` by adding error-messages to it, using `FieldProcessor.addErrorMessage(FieldDef, String)`.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### I18N_VAR

          public static final String I18N_VAR

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### ApplicationRequest

          public ApplicationRequest()

    - #### ApplicationRequest

          public ApplicationRequest(Request request,
                                    PermissionProcessor permissionProcessor,
                                    RequestSupport requestSupport)

  - ### Method Detail

    - #### getPermissionProcessor

          public PermissionProcessor getPermissionProcessor()

      Description copied from interface: `Request`
      Returns the `PermissionProcessor` for this `Request`.
      Specified by:
        `getPermissionProcessor` in interface `Request`
      Returns:
        the `PermissionProcessor`

    - #### setPermissionProcessor

          public void setPermissionProcessor(PermissionProcessor permissionProcessor)

    - #### getLabelSupport

          public LabelSupport getLabelSupport()

    - #### setLabelSupport

          public void setLabelSupport(LabelSupport labelSupport)

    - #### getWrappedRequest

          public Request getWrappedRequest()

    - #### setWrappedRequest

          public void setWrappedRequest(Request wrappedRequest)

    - #### getEnvironment

          public Environment getEnvironment()

      Description copied from interface: `RequestSupport`
      Returns the `Environment` for this `Request`.
      Specified by:
        `getEnvironment` in interface `RequestSupport`
      Returns:
        the `Environment`

    - #### getRequestSupport

          public RequestSupport getRequestSupport()

    - #### setRequestSupport

          public void setRequestSupport(RequestSupport requestSupport)

    - #### getRedirectTarget

          public String getRedirectTarget()

    - #### setRedirectTarget

          public void setRedirectTarget(String redirectTarget)

    - #### canConvert

          public boolean canConvert(Class<?> sourceType,
                                    Class<?> targetType)

      Specified by:
        `canConvert` in interface `org.springframework.core.convert.ConversionService`

    - #### handleException

          public void handleException(FieldProcessor fp,
                                      Exception e)
                               throws BusinessException

      Description copied from interface: `RequestSupport`
      Handles an `Exception`. If the given Exception is a `BusinessException`, the very same `BusinessException` is being re-thrown. Otherwise, the `Exception` is being wrapped into a new `BusinessException` which is then being thrown.
      If the given `Exception` is a `MessageParam`, `RequestSupport.addErrorMessage(FieldProcessor, MessageParam)` is being called.
      Specified by:
        `handleException` in interface `RequestSupport`
      Parameters:
        `fp` - a `FieldProcessor`
        `e` - an `Exception`
      Throws:
        `BusinessException`
      See Also:
        `MessageParam`, `RequestSupport.addErrorMessage(FieldProcessor, MessageParam)`

    - #### addErrorMessage

          public void addErrorMessage(FieldProcessor fp,
                                      MessageParam localizable)

      Description copied from interface: `RequestSupport`
      Adds an error to the `FieldProcessor` using `FieldProcessor.addErrorMessage(String)`. `MessageParam.getMessageKey()` is used for the message key, `MessageParam.getMessageArgs()` for the message arguments.
      Specified by:
        `addErrorMessage` in interface `RequestSupport`
      Parameters:
        `fp` - a `FieldProcessor`
        `localizable` - a `MessageParam`
      See Also:
        `MessageParam`

    - #### addErrorMessage

          public void addErrorMessage(FieldProcessor fp,
                                      MessageParam localizable,
                                      String fieldBinding)

      Description copied from interface: `RequestSupport`
      Adds an error to a `FieldDef` using `FieldProcessor.addErrorMessage(org.appng.xml.platform.FieldDef, String)`. `MessageParam.getMessageKey()` is used for the message key, `MessageParam.getMessageArgs()` for the message arguments.
      Specified by:
        `addErrorMessage` in interface `RequestSupport`
      Parameters:
        `fp` - a `FieldProcessor`
        `localizable` - a `MessageParam`
        `fieldBinding` - the binding of the `FieldDef` to add the error to
      See Also:
        `MessageParam`

    - #### convert

          public <T> T convert(Object source,
                               Class<T> targetType)

      Specified by:
        `convert` in interface `org.springframework.core.convert.ConversionService`

    - #### setPropertyValues

          public <T> void setPropertyValues(T source,
                                            T target,
                                            MetaData metaData)

      Description copied from interface: `RequestSupport`
      Copies the fields defined by the given `MetaData` from `source` to `target`.
      Specified by:
        `setPropertyValues` in interface `RequestSupport`
      Parameters:
        `source` - the source object to read the fields from
        `target` - the target object to write the fields to
        `metaData` - the `MetaData`

    - #### setPropertyValue

          public <T> void setPropertyValue(T source,
                                           T target,
                                           String property)

      Description copied from interface: `RequestSupport`
      Copies the property from `source` to `target`.
      Specified by:
        `setPropertyValue` in interface `RequestSupport`
      Parameters:
        `source` - the source object to read the property from
        `target` - the target object to write the property to
        `property` - the name of the property to set

    - #### canConvert

          public boolean canConvert(org.springframework.core.convert.TypeDescriptor sourceType,
                                    org.springframework.core.convert.TypeDescriptor targetType)

      Specified by:
        `canConvert` in interface `org.springframework.core.convert.ConversionService`

    - #### convert

          public Object convert(Object source,
                                org.springframework.core.convert.TypeDescriptor sourceType,
                                org.springframework.core.convert.TypeDescriptor targetType)

      Specified by:
        `convert` in interface `org.springframework.core.convert.ConversionService`

    - #### getBindObject

          public Object getBindObject(FieldProcessor fp,
                                      RequestContainer container,
                                      ClassLoader classLoader)
                               throws BusinessException

      Description copied from interface: `RequestSupport`
      Creates, fills and returns a new bindobject. The type of the returned object is obtained from `fp.getMetaData().getBindClass()`. The `MetaData`'s `FieldDef`initions are responsible for which fields are getting filled.
      Specified by:
        `getBindObject` in interface `RequestSupport`
      Parameters:
        `fp` - the current `FieldProcessor`
        `container` - the `RequestContainer` used to retrieve the values for filling the bindobject
        `classLoader` - the `ClassLoader` used to load the bindclass
      Returns:
        a new bindobject
      Throws:
        `BusinessException` - if the bindclass could not be loaded, instantiated or initialized, or if an error occurred during filling the bindobject
      See Also:
        `RequestSupport.fillBindObject(Object, FieldProcessor, RequestContainer, ClassLoader)`

    - #### fillBindObject

          public void fillBindObject(Object instance,
                                     FieldProcessor fp,
                                     RequestContainer container,
                                     ClassLoader classLoader)
                              throws BusinessException

      Description copied from interface: `RequestSupport`
      Fills the given `bindobject` with the (converted) values provided by a `RequestContainer`. The type of the `bindobject` must match `fp.getMetaData().getBindClass()`. The `MetaData`'s `FieldDef`initions are responsible for which fields are getting filled.
      Specified by:
        `fillBindObject` in interface `RequestSupport`
      Parameters:
        `instance` - the bindobject to fill
        `fp` - the current `FieldProcessor`
        `container` - the `RequestContainer` used to retrieve the values for filling the bindobject
        `classLoader` - the `ClassLoader` used to load the bindclass
      Throws:
        `BusinessException` -
        - if the type of the `bindobject` is not assignable from the type returned by `fp.getMetaData().getBindClass()`
        - if the type returned by `fp.getMetaData().getBindClass()` can not be instanciated

    - #### getMessage

          public String getMessage(String key,
                                   Object... args)

      Description copied from interface: `RequestSupport`
      Retrieves a message from the underlying `MessageSource`, using the `Locale` provided by `Environment.getLocale()`.
      Specified by:
        `getMessage` in interface `RequestSupport`
      Parameters:
        `key` - the message key
        `args` - the message arguments

    - #### getMessageSource

          public org.springframework.context.MessageSource getMessageSource()

      Description copied from interface: `RequestSupport`
      Returns the currently used `MessageSource`
      Specified by:
        `getMessageSource` in interface `RequestSupport`
      Returns:
        a `MessageSource`

    - #### getHost

          public String getHost()

      Description copied from interface: `RequestContainer`
      Returns the host name for this request
      Specified by:
        `getHost` in interface `RequestContainer`
      Returns:
        the host name

    - #### getParametersList

          public Map<String,List<String>> getParametersList()

      Description copied from interface: `RequestContainer`
      Returns an immutable `Map` containing the name of each request-parameter as a key and the list of submitted values as value.
      Specified by:
        `getParametersList` in interface `RequestContainer`
      Returns:
        a `Map` containing the request parameters (including multi-valued ones)

    - #### getParameters

          public Map<String,String> getParameters()

      Description copied from interface: `RequestContainer`
      Returns an immutable `Map` containing the name of each request-parameter as a key and a single parameter value as the map's value.
      Note that for multi-valued parameters, the returned map contains any of the submitted values. Use `RequestContainer.getParametersList()` instead if you want to deal with multi-valued parameters.
      Specified by:
        `getParameters` in interface `RequestContainer`
      Returns:
        a `Map` containing the request parameters

    - #### getParameter

          public String getParameter(String name)

      Description copied from interface: `RequestContainer`
      Returns the value for the parameter with the given name.
      Note that for a multi-valued parameter, any of the submitted values is returned. Use `RequestContainer.getParameterList(String)` instead if you want to deal with a multi-valued parameter.
      Specified by:
        `getParameter` in interface `RequestContainer`
      Parameters:
        `name` - the name of the parameter
      Returns:
        the value of the parameter (may be null)

    - #### getHttpServletRequest

          public javax.servlet.http.HttpServletRequest getHttpServletRequest()

    - #### getParameterNames

          public Set<String> getParameterNames()

      Description copied from interface: `RequestContainer`
      Returns an immutable `Set` containing the names of all request parameters.
      Specified by:
        `getParameterNames` in interface `RequestContainer`
      Returns:
        the parameters names

    - #### getEncoding

          public String getEncoding()

    - #### hasParameter

          public boolean hasParameter(String name)

      Description copied from interface: `RequestContainer`
      Checks whether a parameter with the given name exists.
      Specified by:
        `hasParameter` in interface `RequestContainer`
      Parameters:
        `name` - the name of the parameter
      Returns:
        `true` if such a parameter exists, `false` otherwise

    - #### setEncoding

          public void setEncoding(String encoding)

    - #### getParameterList

          public List<String> getParameterList(String name)

      Description copied from interface: `RequestContainer`
      Returns a `List` containing all the values for the parameter with the given name.
      Specified by:
        `getParameterList` in interface `RequestContainer`
      Parameters:
        `name` - the name of the parameter
      Returns:
        a `List` (never `null`, but may be empty) containing all the values for the given parameter

    - #### isMultiPart

          public boolean isMultiPart()

    - #### isPost

          public boolean isPost()

      Description copied from interface: `Request`
      Checks whether this `Request` originates of a HTTP POST-request.
      Specified by:
        `isPost` in interface `Request`
      Returns:
        `true` if this `Request` originates of a HTTP POST-request, `false` otherwise

    - #### getFormUploads

          public Map<String,List<FormUpload>> getFormUploads()

      Description copied from interface: `RequestContainer`
      Returns all `FormUpload`s for the request as immutable map. Returns a `Map` using the parameters name as a key and a `List` of `FormUpload`s as the value.
      Specified by:
        `getFormUploads` in interface `RequestContainer`
      Returns:
        a `Map` containing the `FileUpload`s

    - #### isGet

          public boolean isGet()

      Description copied from interface: `Request`
      Checks whether this `Request` originates of a HTTP GET-request.
      Specified by:
        `isGet` in interface `Request`
      Returns:
        `true` if this `Request` originates of a HTTP GET-request, `false` otherwise

    - #### isValid

          public boolean isValid()

    - #### setTempDir

          public void setTempDir(File tempDir)

    - #### getFormUploads

          public List<FormUpload> getFormUploads(String name)

      Description copied from interface: `RequestContainer`
      Returns an immutable `List` of all `FormUpload`s for the parameter with the given name.
      Specified by:
        `getFormUploads` in interface `RequestContainer`
      Parameters:
        `name` - the name of the parameters
      Returns:
        a list if `FormUpload`s (never `null`, but may be empty)

    - #### setMaxSize

          public void setMaxSize(long maxSize)

    - #### setMaxSize

          public void setMaxSize(long maxSize,
                                 boolean strict)

    - #### setAcceptedTypes

          public void setAcceptedTypes(String uploadName,
                                       String... types)

    - #### getAcceptedTypes

          public List<String> getAcceptedTypes(String uploadName)

    - #### addParameters

          public void addParameters(Map<String,String> singleParameters)

    - #### addParameters

          public void addParameters(String name,
                                    List<String> values)

    - #### addParameter

          public void addParameter(String key,
                                   String value)

    - #### getSubject

          public Subject getSubject()

      Description copied from interface: `Request`
      Returns the `Subject` for this `Request`.
      Specified by:
        `getSubject` in interface `Request`
      Returns:
        the `Subject`

    - #### getLocale

          public Locale getLocale()

      Description copied from interface: `Request`
      Returns the `Locale` for this `Request`.
      Specified by:
        `getLocale` in interface `Request`
      Returns:
        the `Locale`

    - #### getExpressionEvaluator

          public ExpressionEvaluator getExpressionEvaluator()

      Description copied from interface: `Request`
      Returns the `ExpressionEvaluator` for this `Request`.
      Specified by:
        `getExpressionEvaluator` in interface `Request`
      Returns:
        the `ExpressionEvaluator`

    - #### getParameterSupportDollar

          public ParameterSupport getParameterSupportDollar()

      Description copied from interface: `Request`
      Returns the `ParameterSupport` for this `Request`.
      Specified by:
        `getParameterSupportDollar` in interface `Request`
      Returns:
        the `ParameterSupport`

    - #### isRedirect

          public boolean isRedirect()

      Description copied from interface: `Request`
      Checks whether a redirect-target has been set for this `Request`.
      Specified by:
        `isRedirect` in interface `Request`
      Returns:
        `true` if a redirect-target has been set for this `Request`, `false` otherwise

    - #### setLabels

          public void setLabels(Config config)

    - #### setLabels

          public final void setLabels(Config config,
                                      ParameterSupport fieldParameters)

    - #### setLabel

          public void setLabel(Label label)

    - #### setLabels

          public void setLabels(Labels labels)

    - #### getFieldConverter

          public FieldConverter getFieldConverter()

      Description copied from interface: `RequestSupport`
      Returns a `FieldConverter`
      Specified by:
        `getFieldConverter` in interface `RequestSupport`
      Returns:
        a `FieldConverter`

    - #### getApplicationConfig

          public ApplicationConfigProvider getApplicationConfig()

    - #### setApplicationConfig

          public void setApplicationConfig(ApplicationConfigProvider applicationConfigProvider)

    - #### getValidationProvider

          public ValidationProvider getValidationProvider()

    - #### setValidationProvider

          public void setValidationProvider(ValidationProvider validationProvider)

    - #### getUrlParameters

          public List<String> getUrlParameters()

      Description copied from interface: `Request`
      Returns a list of URL-Parameters for a JSP-page, which are those path-elements appearing after the name of the JSP-page itself. So if the page is named `contact` and the path is `/contact/europe/germany`, the resulting `List` would be equal to `Arrays.asList("europe","germany")`.
      Specified by:
        `getUrlParameters` in interface `Request`
      Returns:
        the URL-Parameters for a JSP-Page
      See Also:
        `Path.getJspUrlParameters()`

    - #### setUrlParameters

          public void setUrlParameters(List<String> urlParameters)

    - #### validateBean

          public void validateBean(Object bean,
                                   FieldProcessor fp,
                                   Class<?>... groups)

      Description copied from interface: `ValidationProvider`
      Validates the given bean by adding error-messages to the `FieldDef` initions, using `FieldProcessor.addErrorMessage(FieldDef, String)`.
      Specified by:
        `validateBean` in interface `ValidationProvider`
      Parameters:
        `bean` - the bean to validate
        `fp` - the `FieldProcessor` containing the `MetaData` for the bean
        `groups` - the JSR-303 validation groups to use
      See Also:
        `FieldProcessor.addErrorMessage(FieldDef, String)`

    - #### validateBean

          public void validateBean(Object bean,
                                   FieldProcessor fp,
                                   String[] excludeBindings,
                                   Class<?>... groups)

      Description copied from interface: `ValidationProvider`
      Validates the given bean by adding error-messages to the `FieldDef` initions, using `FieldProcessor.addErrorMessage(FieldDef, String)`.
      Specified by:
        `validateBean` in interface `ValidationProvider`
      Parameters:
        `bean` - the bean to validate
        `fp` - the `FieldProcessor` containing the `MetaData` for the bean
        `excludeBindings` - an array of field-bindings to ignore during validation
        `groups` - the JSR-303 validation groups to use
      See Also:
        `FieldProcessor.addErrorMessage(FieldDef, String)`

    - #### validateField

          public void validateField(Object bean,
                                    FieldProcessor fp,
                                    String fieldBinding,
                                    Class<?>... groups)

      Description copied from interface: `ValidationProvider`
      Validates a single `FieldDef` by adding error-messages to it, using `FieldProcessor.addErrorMessage(FieldDef, String)`.
      Specified by:
        `validateField` in interface `ValidationProvider`
      Parameters:
        `bean` - the bean to validate
        `fp` - the `FieldProcessor` containing the `MetaData` for the bean
        `fieldBinding` - the binding of the `FieldDef` to validate
        `groups` - the JSR-303 validation groups to use
      See Also:
        `FieldProcessor.addErrorMessage(FieldDef, String)`

    - #### addValidationMetaData

          public void addValidationMetaData(MetaData metaData,
                                            ClassLoader classLoader,
                                            Class<?>... groups)
                                     throws ClassNotFoundException

      Description copied from interface: `ValidationProvider`
      Based on the JSR-303 annotations of the `MetaData`'s bindclass, this method adds the `Validation` to the `FieldDef`initions.
      Specified by:
        `addValidationMetaData` in interface `ValidationProvider`
      Parameters:
        `metaData` - the `MetaData` to add the `Validation`s to
        `classLoader` - the `ClassLoader` to load the `MetaData`s bindClass
        `groups` - the JSR-303 validation groups to use
      Throws:
        `ClassNotFoundException` - if the bindClass can not be loaded
      See Also:
        `Min`, `Max`, `Size`, `Digits`, `NotNull`, `Future`, `Past`, `Type`, `Pattern`, `FileUpload`

    - #### headers

          public org.springframework.http.HttpHeaders headers()

      Description copied from interface: `Request`
      Returns the `HttpHeaders` for the underlying `HttpServletRequest`.
      Specified by:
        `headers` in interface `Request`
      Returns:
        the headers

    - #### applicationPath

          public ApplicationRequest.ApplicationPath applicationPath()

      Creates a new `ApplicationRequest.ApplicationPath` to be used to evaluate include-conditions on a page.
      Returns:
        the `ApplicationRequest.ApplicationPath`
      Since:
        1.21
      See Also:
        `Path.getApplicationUrlParameters()`

Copyright © 2011–2023 aiticon GmbH. All rights reserved.